diff --git a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
index 718229033..d7524bc80 100644
--- a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
@@ -1,33 +1,29 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.List;
 import java.util.Random;
 
 public class BlockPressurePlate extends Block
 {
-    private final MobType triggerMobType;
+    private final Class<? extends Entity> triggerMobClass;
 
-    public enum MobType
-    {
-        EVERYTHING,
-        MOBS,
-        PLAYERS
-    }
-
-	public BlockPressurePlate(String key, int id, MobType mobType, Material material)
+	public BlockPressurePlate(String key, int id, Class<? extends Entity> mobType, Material material)
     {
         super(key, id, material);
-        triggerMobType = mobType;
+        triggerMobClass = mobType;
         setTicking(true);
         float pixel = 1 / 16f;
         setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, pixel / 2, 1.0F - pixel);
@@ -60,13 +56,13 @@ public class BlockPressurePlate extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) || world.isBlockNormalCube(x, y + 1, z);
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        boolean flag = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        boolean flag = !canPlaceBlockAt(world, x, y, z);
         if(flag)
         {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
@@ -81,7 +77,7 @@ public class BlockPressurePlate extends Block
         {
             return;
         }
-        if (world.getBlockMetadata(x, y, z) != 0) {
+        if (isPressed(world.getBlockMetadata(x, y, z))) {
             updateState(world, x, y, z);
         }
     }
@@ -93,46 +89,36 @@ public class BlockPressurePlate extends Block
         {
             return;
         }
-        if (world.getBlockMetadata(x, y, z) != 1) {
+        if (!isPressed(world.getBlockMetadata(x, y, z))) {
             updateState(world, x, y, z);
         }
     }
 
     private void updateState(World world, int x, int y, int z)
     {
-        boolean isPressed = world.getBlockMetadata(x, y, z) == 1;
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPressed = isPressed(meta);
+        boolean isCeiling = (meta & 0b10) != 0;
         boolean isSteppedOn = false;
         float f = 0.125F;
-        List<Entity> list = null;
-        if(triggerMobType == MobType.EVERYTHING)
-        {
-            list = world.getEntitiesWithinAABBExcludingEntity(null, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(triggerMobType == MobType.MOBS)
-        {
-            list = world.getEntitiesWithinAABB(EntityLiving.class, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(triggerMobType == MobType.PLAYERS)
-        {
-            list = world.getEntitiesWithinAABB(EntityPlayer.class, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(list != null && list.size() > 0)
+        List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getBoundingBoxFromPool((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
+        if(list != null && !list.isEmpty())
         {
             isSteppedOn = true;
         }
         if(isSteppedOn && !isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, 1);
+            world.setBlockMetadataWithNotify(x, y, z, meta | 0b01);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.6F);
         }
         if(!isSteppedOn && isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, 0);
+            world.setBlockMetadataWithNotify(x, y, z, meta & 0b10);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.5F);
         }
@@ -145,10 +131,11 @@ public class BlockPressurePlate extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        if(data > 0)
+        boolean isCeiling = (world.getBlockMetadata(x, y, z) & 0b10) != 0;
+        if(isPressed(data))
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
         }
         super.onBlockRemoved(world, x, y, z, data);
     }
@@ -156,14 +143,24 @@ public class BlockPressurePlate extends Block
     @Override
     public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
     {
-        boolean isPressed = world.getBlockMetadata(x, y, z) == 1;
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPressed = isPressed(meta);
+        boolean isCeiling = (meta & 0b10) != 0;
         float pixel = 0.0625F;
         if(isPressed)
         {
-            setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
+            if (isCeiling){
+                setBlockBounds(pixel, 1f - 0.03125F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            } else {
+                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
+            }
         } else
         {
-            setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
+            if (isCeiling){
+                setBlockBounds(pixel, 1f - 0.0625F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            } else {
+                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
+            }
         }
     }
 
@@ -171,20 +168,25 @@ public class BlockPressurePlate extends Block
     public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
     {
 
-        return blockAccess.getBlockMetadata(x, y, z) > 0;
+        return isPressed(blockAccess.getBlockMetadata(x, y, z));
     }
 
     @Override
     public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
     {
-        if(world.getBlockMetadata(x, y, z) == 0)
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isCeiling = (meta & 0b10) != 0;
+        if(isPressed(world.getBlockMetadata(x, y, z)))
         {
-            return false;
+            return side == (isCeiling ? 0 : 1);
         } else
         {
-            return side == 1;
+            return false;
         }
     }
+    public boolean isPressed(int meta){
+        return (meta & 0b1) != 0;
+    }
 
     @Override
     public boolean canProvidePower()
@@ -197,4 +199,10 @@ public class BlockPressurePlate extends Block
     {
         return 1;
     }
+    @Override
+    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && sideHeight > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
+            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b10);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockSpikes.java b/src/main/java/net/minecraft/core/block/BlockSpikes.java
index 2223c0c3a..7d39736bb 100644
--- a/src/main/java/net/minecraft/core/block/BlockSpikes.java
+++ b/src/main/java/net/minecraft/core/block/BlockSpikes.java
@@ -89,7 +89,7 @@ public class BlockSpikes extends BlockCobweb
     }
 
     @Override
-    public boolean collidesWithEntity(Entity entity) {
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         return !(entity instanceof EntityItem);
     }
     
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 735a94100..a21ea60a5 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -162,6 +162,6 @@ public class TileEntity
         addMapping(TileEntityFlag.class, "Flag");
         addMapping(TileEntitySeat.class, "Seat");
         addMapping(TileEntityFlowerJar.class, "FlowerJar");
-
+        addMapping(TileEntityMeshGold.class, "MeshGold");
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
new file mode 100644
index 000000000..67a716780
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -0,0 +1,61 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.Packet140TileEntityData;
+import org.jetbrains.annotations.Nullable;
+
+public class TileEntityMeshGold extends TileEntity{
+    @Nullable
+    public ItemStack filterItem;
+    public int ticksRan = 0;
+    public TileEntityMeshGold() {
+    }
+
+    public void tick()
+    {
+        if (ticksRan == 0){
+            ticksRan = worldObj.rand.nextInt(360);
+        }
+        ticksRan++;
+    }
+    public boolean setFilterItem(EntityPlayer player, @Nullable ItemStack stack){
+        boolean flag = false;
+        boolean wasNull = filterItem == null;
+        if (filterItem != null && player.getGamemode().consumeBlocks()){
+            player.inventory.insertItem(filterItem, true);
+            flag = true;
+        }
+        if (stack != null) {
+            stack.consumeItem(player);
+            filterItem = new ItemStack(stack.getItem(), 1, stack.getMetadata(), stack.getData());
+            return true;
+        }
+        filterItem = null;
+        return flag | !wasNull;
+    }
+    @Override
+    public void readFromNBT(CompoundTag compoundTag)
+    {
+        super.readFromNBT(compoundTag);
+        if (compoundTag.getBoolean("hasItem")){
+            filterItem = ItemStack.readItemStackFromNbt(compoundTag.getCompound("item"));
+        }
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag compoundTag)
+    {
+        super.writeToNBT(compoundTag);
+        if (filterItem != null){
+            compoundTag.putCompound("item", filterItem.writeToNBT(new CompoundTag()));
+            compoundTag.putBoolean("hasItem", true);
+        }
+    }
+    @Override
+    public Packet getDescriptionPacket() {
+        return new Packet140TileEntityData(this);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/src/main/java/net/minecraft/core/entity/EntityItem.java
index 1f578227a..9a85cadd1 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -31,7 +31,7 @@ public class EntityItem extends Entity
         super(world);
         age = 0;
         health = 5;
-        field_804_d = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
+        initialRotation = (float)(java.lang.Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
         setPos(d, d1, d2);
@@ -57,7 +57,7 @@ public class EntityItem extends Entity
         super(world);
         age = 0;
         health = 5;
-        field_804_d = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
+        initialRotation = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
     }
@@ -272,7 +272,7 @@ public class EntityItem extends Entity
     public int age;
     public int delayBeforeCanPickup;
     private int health;
-    public float field_804_d;
+    public float initialRotation;
     public int basketPickupDelay = 0;
     public static boolean enableItemClumping = true;
 }
diff --git a/src/main/java/net/minecraft/core/net/ServerAddress.java b/src/main/java/net/minecraft/core/net/ServerAddress.java
new file mode 100644
index 000000000..df4a0c685
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/ServerAddress.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.net;
+
+import javax.naming.directory.Attributes;
+import javax.naming.directory.InitialDirContext;
+import java.util.Hashtable;
+
+public class ServerAddress {
+    private final String ipAddress;
+    private final int serverPort;
+
+    private ServerAddress(String ip, int port) {
+        this.ipAddress = ip;
+        this.serverPort = port;
+    }
+
+    public String getIP() {
+        return this.ipAddress;
+    }
+
+    public int getPort() {
+        return this.serverPort;
+    }
+
+    public static ServerAddress resolveServerIP(String ipToResolve) {
+        if (ipToResolve == null) {
+            return null;
+        } else {
+            String[] ipSplit = ipToResolve.split(":");
+            if (ipToResolve.startsWith("[")) {
+                int ipv6End = ipToResolve.indexOf("]");
+                if (ipv6End > 0) {
+                    String ipv6IP = ipToResolve.substring(1, ipv6End);
+                    String port = ipToResolve.substring(ipv6End + 1).trim();
+                    if (port.startsWith(":") && !port.isEmpty()) {
+                        port = port.substring(1);
+                        ipSplit = new String[]{ipv6IP, port};
+                    } else {
+                        ipSplit = new String[]{ipv6IP};
+                    }
+                }
+            }
+
+            if (ipSplit.length > 2) {
+                ipSplit = new String[]{ipToResolve};
+            }
+
+            String ip = ipSplit[0];
+            int port = ipSplit.length > 1 ? parseIntWithDefault(ipSplit[1], 25565) : 25565;
+            if (port == 25565) {
+                String[] recordSplit = resolveSRVRecord(ip);
+                ip = recordSplit[0];
+                port = parseIntWithDefault(recordSplit[1], 25565);
+            }
+
+            return new ServerAddress(ip, port);
+        }
+    }
+
+    private static String[] resolveSRVRecord(String ip) {
+        try {
+            Hashtable<String, String> contextTable = new Hashtable<>();
+            contextTable.put("java.naming.factory.initial", "com.sun.jndi.dns.DnsContextFactory");
+            contextTable.put("java.naming.provider.url", "dns:");
+            InitialDirContext context = new InitialDirContext(contextTable);
+            Attributes attr = context.getAttributes("_minecraft._tcp." + ip, new String[]{"SRV"});
+            String[] ipSplit = attr.get("srv").get().toString().split(" ", 4);
+            return new String[]{ipSplit[3], ipSplit[2]};
+        } catch (Throwable t) {
+            return new String[]{ip, Integer.toString(25565)};
+        }
+    }
+
+    private static int parseIntWithDefault(String str, int defaultVal) {
+        try {
+            return Integer.parseInt(str.trim());
+        } catch (Exception e) {
+            return defaultVal;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/ServerData.java b/src/main/java/net/minecraft/core/net/ServerData.java
index 68b8dc554..308fcc8de 100644
--- a/src/main/java/net/minecraft/core/net/ServerData.java
+++ b/src/main/java/net/minecraft/core/net/ServerData.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.net;
 
 import com.mojang.nbt.CompoundTag;
+import org.apache.logging.log4j.core.jmx.Server;
 
 import java.time.LocalDateTime;
 import java.time.ZoneOffset;
@@ -40,19 +41,7 @@ public class ServerData
         tag.putCompound(Integer.toString(index), subTag);
     }
 
-    public String getHostName()
-    {
-        String[] split = address.split(":");
-        return split[0];
-    }
-
-    public int getPort()
-    {
-        String[] split = address.split(":");
-        try {
-            return Integer.parseInt(split[split.length - 1]);
-        } catch (NumberFormatException e) {
-            return 25565;
-        }
+    public ServerAddress getServerAddress() {
+        return ServerAddress.resolveServerIP(address);
     }
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
index fb88ea2d7..523592ef8 100644
--- a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
+++ b/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
@@ -18,6 +18,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.Nullable;
 
 public class InventoryPlayer
     implements IInventory
@@ -32,6 +33,7 @@ public class InventoryPlayer
         this.player = player;
     }
 
+    @Nullable
     public ItemStack getCurrentItem()
     {
         if(currentItem < 9 + hotbarOffset && currentItem >= hotbarOffset)
diff --git a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
index 951ec9d27..c64eaaa84 100644
--- a/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
+++ b/src/main/java/net/minecraft/core/sound/BlockSoundDispatcher.java
@@ -284,6 +284,7 @@ public class BlockSoundDispatcher
         addDispatch(Block.doorIronTop, BlockSounds.METAL);
 
         addDispatch(Block.mesh, BlockSounds.METAL);
+        addDispatch(Block.meshGold, BlockSounds.METAL);
 
         addDispatch(Block.bed, BlockSounds.WOOD);
         addDispatch(Block.seat, BlockSounds.WOOD);
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 15a4a1967..59cbacaac 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1442,7 +1442,7 @@ public class World implements WorldSource {
                     if(block != null)
                     {
                         int metadata = getBlockMetadata(dx, dy, dz);
-                        if (block.collidesWithEntity(entity) && entity.collidesWithBlock(block, metadata))
+                        if (block.collidesWithEntity(entity, this, dx, dy, dz) && entity.collidesWithBlock(block, metadata))
                         {
                             block.getCollidingBoundingBoxes(this, dx, dy, dz, axisalignedbb, collidingBoundingBoxes);
                         }
